﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Locomotive
{
    internal class DrawningWarmlyLocomotive : DrawningLocomotive
    {
        public DrawningWarmlyLocomotive(int speed, float weight, Color bodyColor, Color extraColor, bool pipe, bool storage) 
            : base(speed, weight, bodyColor, locomotiveWidth: 130, locomotiveHeight: 70)
        {
            Locomotive = new EntityWarmlyLocomotive(speed, weight, bodyColor, extraColor, pipe, storage);
        }

        public void SetExtraColor(Color color)
        {
            Locomotive = Locomotive as EntityWarmlyLocomotive;
            if (Locomotive is not null)
            {
                Locomotive = new EntityWarmlyLocomotive(Locomotive.Speed, Locomotive.Weight, Locomotive.BodyColor, color, (Locomotive as EntityWarmlyLocomotive).Pipe, (Locomotive as EntityWarmlyLocomotive).FuelStorage);
            }
        }

        public override void DrawTransport(Graphics g)
        {
            if (Locomotive is not EntityWarmlyLocomotive warmlyLocomotive)
            {
                return;
            }

            Pen pen = new(Color.Black);
            Brush extraBrush = new SolidBrush(warmlyLocomotive.ExtraColor);
            

            if (warmlyLocomotive.FuelStorage)
            {
                g.FillRectangle(extraBrush, _startPosX + 10, _startPosY, 30, 20);
                g.FillRectangle(extraBrush, _startPosX + 60, _startPosY, 20, 20);
                g.FillRectangle(extraBrush, _startPosX + 60, _startPosY + 10, 30, 10);
            }

            if (warmlyLocomotive.Pipe)
            {
                g.FillRectangle(extraBrush, _startPosX + 110, _startPosY + 10, 10, 50);
                g.FillRectangle(extraBrush, _startPosX + 110, _startPosY + 40, 20, 20);
                g.FillRectangle(extraBrush, _startPosX + 100, _startPosY, 30, 10);
            }

            _startPosY += 20;

            base.DrawTransport(g);

            _startPosY -= 20;


        }

    }
}
