﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Locomotive
{
    public class EntityLocomotive
    {
        /// Скорость
        public int Speed { get; private set; }
        /// Вес
        public float Weight { get; private set; }
        /// Цвет 
        public Color BodyColor { get; private set; }
        /// Шаг перемещения локомотива
        public float Step => Speed * 100 / Weight;

        public EntityLocomotive(int speed, float weight, Color bodyColor)
        {
            Random rnd = new();
            Speed = speed <= 0 ? rnd.Next(50, 150) : speed;
            Weight = weight <= 0 ? rnd.Next(40, 70) : weight;
            BodyColor = bodyColor;
        }
    }
}
