﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Locomotive
{
    internal class RailroadMap : AbstractMap
    {
        /// Цвет участка закрытого
        private readonly Brush barrierColor = new SolidBrush(Color.Black);
        /// Цвет участка открытого
        private readonly Brush roadColor = new SolidBrush(Color.Pink);

        protected override void DrawBarrierPart(Graphics g, int i, int j)
        {
            g.FillRectangle(barrierColor, i * _size_x, j * _size_y, i * (_size_x +
           1), j * (_size_y + 1));
        }

        protected override void DrawRoadPart(Graphics g, int i, int j)
        {
            g.FillRectangle(roadColor, i * _size_x, j * _size_y, i * (_size_x +
           1), j * (_size_y + 1));
        }

        protected override void GenerateMap()
        {
            _map = new int[100, 100];
            _size_x = (float)_width / _map.GetLength(0);
            _size_y = (float)_height / _map.GetLength(1);
            int counter = 0;
            for (int i = 0; i < _map.GetLength(0); ++i)
            {
                for (int j = 0; j < _map.GetLength(1); ++j)
                {
                    _map[i, j] = _freeRoad;
                }
            }
            while (counter < 1)
            {
                int y = _random.Next(0, 95);
                
                for(int x = 0; x < 99; x++)
                {
                    _map[x, y] = _barrier;
                    _map[x, y + 5] = _barrier;

                    if (x % 5 == 0)
                    {
                        _map[x, y + 1] = _barrier;
                        _map[x, y + 2] = _barrier;
                        _map[x, y + 3] = _barrier;
                        _map[x, y + 4] = _barrier;
                    }
                }
                counter += 1;
            }
        }
    }
}
